<?php

/*
Plugin Name: WPShout Ajax File Copier
Description: Demo for Ajax file copying to avoid PHP memory and timeout limits
Author: WPShout
Author URI: https://wpshout.com/
*/

add_action( 'wp_enqueue_scripts', 'wpshout_ajax_copier_script' );
function wpshout_ajax_copier_script() {
	if( is_single( 'Above and Beyond: Avoiding PHP Timeout and Memory Limit Errors with AJAX' ) ) {
		wp_enqueue_script( 'wpshout-ajax-file-copier', plugin_dir_url( __FILE__ ) . 'wpshout-ajax-file-copier.js', array( 'jquery' ) );

		$target_files = array(
			'ebook.mobi', 'podcast.mp3', 'video.mp4'
		);

		wp_localize_script( 'wpshout-ajax-file-copier', 'ajax_vars', array( 'ajax_url' => admin_url( 'admin-ajax.php' ), 'target_files' => $target_files ) );
	}
}

add_action( 'wp_ajax_wpshout_copy_file_over', 'wpshout_php_file_copier' );
add_action( 'wp_ajax_nopriv_wpshout_copy_file_over', 'wpshout_php_file_copier' );
function wpshout_php_file_copier() {
	$file = $_POST['file'];
	$base = 'https://pressupinc.com/';

	$filestring = file_get_contents( $base . $file );

	$bytes = file_put_contents( get_home_path() . $file, $filestring );

	if( $bytes === false ) {
		echo '-1';
	} else {
		echo $bytes;
	}

	die;
}